#!/bin/bash
#
# forward1.cgi
# ndert die Eintrge in der /$HOME/.forward Datei eines Nutzers zur
# E-Mail-Weiterleitung
#
# Copyright (C) Gerhard Rhner, 1999
# Anpassung an V4.0 mit LDAP von Reiner Klaproth

forwardchange ()
{
 local SU_ID=SuSuSuSu
 local OK_ID=OkOkOkOk

 if [ "${FORM_kopie}" = "ja" ]; then
   FORM_kopie=$FORM_user
 else
   FORM_kopie=""
 fi

 local RESULT="$(echo "${FORM_pass}" | su -s /bin/bash -l -c "(echo "${SU_ID}"; \
   { echo "${FORM_pass}" | sudo /usr/sbin/forwardchange \"$home\" \"${FORM_weiteran}\" \"${FORM_kopie}\" > /dev/null ; } \
   && echo "${OK_ID}" )" ${FORM_user} )"

 test -n "$(echo "${RESULT}" | grep "${OK_ID}")" && return 0
 test -n "$(echo "${RESULT}" | grep "${SU_ID}")" && return 1

}

read QUERY_STRING
export QUERY_STRING
eval `cgiparse -form` 

cgiutils -ct text/html -cl de -expires now
cat << xxxxxEOFxxxxx

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>E-Mail-Weiterleitung bearbeiten</title>
</head>
<body background="whttxtr2.jpg">
<h1 align=center>E-Mail-Weiterleitung &auml;ndern</h1>
<hr>
xxxxxEOFxxxxx

FEHLER=0
# TMPFILE anlegen
TMPFILE=`mktemp -q /var/apache/tmp/fwdchange.XXXXXX`
if [ $? -ne 0 ]; then
	echo "<FONT COLOR=\"#A00000\">Schwerer Fehler im Interface!<BR>Ich gebe auf!</FONT></H3>"
	echo "</BODY></HTML>"
	exit 0
fi
# Stufe 1: Gibts den User?
echo "${FORM_user}" | grep -q -v -E "[^A-Za-z0-9]"
if [ $? -gt 0 -o ${#FORM_user} -lt 3 ] ; then
         echo "<P><FONT COLOR=\"#800000\">Der Nutzername war ung%uuml;ltig!</FONT><BR>"
	 FEHLER=1
    else
	ldapsearch -x -LLL "(uid=${FORM_user})" gidNumber > $TMPFILE
	x=`grep "gidNumber:" $TMPFILE | cut -d: -f2`
	if [ -z "$x" ]; then
	    echo "<P><FONT COLOR=\"#800000\">Zugriff abgelehnt!</FONT><BR>"
	    FEHLER=1
	elif [ $((x)) -lt 101 ]; then
	    echo "<P><FONT COLOR=\"#800000\">Zugriff abgelehnt!</FONT><BR>"
	    FEHLER=1
	fi
fi
# Zweite Stufe: Ist das Passwort brauchbar?
echo "${FORM_pass}" | grep -q -v -E "[^A-Za-z0-9_-]"
if [ $? != 0 -o ${#FORM_pass} -lt 3 ] ; then
	echo "<P><FONT COLOR=\"#A00000\">Das Passwort war ung&uuml;ltig!</FONT><BR>"
	FEHLER=1
fi
# Der Rest geht nur, wenn das Passwort auch stimmt. Testen wir das mal per LDAP.
if [ $FEHLER = 0 ]; then
	dn=`grep "^dn:" $TMPFILE | cut -d: -f2`
	ldapsearch -x -LLL -D"$dn" -w "${FORM_pass}" "(uid=${FORM_user})" homeDirectory > $TMPFILE 2>/dev/null
	home=`grep "homeDirectory:" $TMPFILE | cut -d: -f2 `
	if [ -z "$home" ]; then
		echo "<P><FONT COLOR=\"#800000\">Das Passwort war falsch!</FONT><BR>"
		FEHLER=1
	fi
fi
# OK, packen wir's an
if [ $FEHLER = 0 ]; then
	forwardchange  
	RESULT="${?}"
	if [ "${RESULT}" = "0" ]; then
		echo "<P><FONT COLOR="#008000">E-Mail-Weiterleitung ge&auml;ndert!</FONT>"
	   else
		echo "<P><FONT COLOR="#800000">Zugriff abgelehnt!</FONT><BR>"
		FEHLER=1
	fi
fi
if [ $FEHLER = 1 ]; then
     echo "<p>Die Weiterleitung wurde nicht ge&auml;ndert!</p>"
     echo "<p><a href=\"forward.php\"><img src=\"redarrow.gif\" align=bottom border=0 width=25 height=13>Versuchen Sie es noch einmal! </a></p>"
fi

cat << xxxxxEOFxxxxx
<hr>
<address>
&copy; <a href="mailto:roehner@informatik.tu-darmstadt.de">Gerhard R&ouml;hner</a>,
06.03.1999<br>
Anpassung an LDAP von Reiner Klaproth, 29.06.2003
</address>
</body>
</html>
xxxxxEOFxxxxx

