#!/bin/bash
#
# change.cgi
# Neufassung fr V4.0 mit LDAP 
# (c) Reiner Klaproth <klaproth@online.de>, 29.06.2003
# 

read QUERY_STRING
export QUERY_STRING
eval `cgiparse -form` 

cgiutils -ct text/html -cl de -expires now

cat << xxxxxEOFxxxxx

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Unix-Passwort &Auml;ndern</title>
</head>
<body background="whttxtr2.jpg">
<h1 align=center>Passwort &auml;ndern</h1>
<hr>
<h3 align=center><font color="#FF0000">Schlie&szlig;en Sie den Browser, bevor
Sie den Arbeitsplatz verlassen!</font></h3>
<hr>
<CENTER><H3>
xxxxxEOFxxxxx

if [ "${FORM_newpass}" = "${FORM_newpass1}" ]; then
	FEHLER=0
	# TMPFILE anlegen
	TMPFILE=`mktemp -q /var/apache/tmp/passchange.XXXXXX`
	if [ $? -ne 0 ]; then
		echo "<FONT COLOR=\"#A00000\">Schwerer Fehler im Interface!<BR>Ich gebe auf!</FONT></H3>"
		echo "</BODY></HTML>"
		exit 0
	fi
	# Stufe 1: Gibts den User?
	echo "${FORM_uid}" | grep -q -v -E "[^A-Za-z0-9]"
	if [ $? -gt 0 -o ${#FORM_uid} -lt 3 ] ; then
	         echo "<P><FONT COLOR=\"#800000\">Der Nutzername war ung%uuml;ltig!</FONT><BR>"
		 FEHLER=1
	    else
		ldapsearch -x -LLL "(uid=${FORM_uid})" gidNumber > $TMPFILE
		x=`grep "gidNumber:" $TMPFILE | cut -d: -f2`
		if [ -z "$x" ]; then
		    echo "<P><FONT COLOR=\"#800000\">Zugriff abgelehnt!</FONT><BR>"
		    FEHLER=1
		elif [ $((x)) -lt 101 ]; then
		    echo "<P><FONT COLOR=\"#800000\">Zugriff abgelehnt!</FONT><BR>"
		    FEHLER=1
		fi
	fi
	# Zweite Stufe: Ist das Passwort brauchbar?
	lpass=${#FORM_newpass}
	if [ $lpass -lt 5 ]; then
	         echo "<P><FONT COLOR=\"#800000\">Das neue Passwort war zu kurz!</FONT><BR>"
		 FEHLER=1
	fi
	echo "${FORM_newpass}" | grep -q -v -E "[^A-Za-z0-9_-]"
	if [ $? -gt 0 ] ; then
		echo "<P><FONT COLOR=\"#800000\">Das neue Passwort enthielt ung&uuml;ltige Zeichen! </FONT><BR>"
		FEHLER=1
	fi
	# letzter Test: funzt das alte Passwort?
	echo "${FORM_oldpass}" | grep -q -v -E "[^A-Za-z0-9_-]"
	if [ $? -gt 0 -o ${#FORM_oldpass} -lt 3 ] ; then
	         echo "<P><FONT COLOR=\"#A00000\">Das alte Passwort war ung&uuml;ltig!</FONT><BR>"
		 FEHLER=1
	fi
	if [ $FEHLER = 0 ]; then
		# Jetzt wirds ernst: Wir ndern das Passwort. 
		# Erst mal das neue Passwort umwandeln
		lnxpass=`/usr/sbin/slappasswd -s ${FORM_newpass}`
		winpass=`/usr/sbin/mkntpwd ${FORM_newpass}`
		lmpass=`echo $winpass | cut -d: -f1`
		ntpass=`echo $winpass | cut -d: -f2`
		
		# Zugang mit den Daten aus TMPFILE
		dn=`grep "^dn:" $TMPFILE`
		
		echo "$dn
changetype: modify
replace: userPassword
userPassword: $lnxpass
-
replace: lmpassword
lmpassword: $lmpass
-
replace: ntpassword
ntpassword: $ntpass
" > $TMPFILE
		dnbind=`echo $dn | cut -d: -f2`
		/usr/bin/ldapmodify -x -D "$dnbind" -w "${FORM_oldpass}" -f $TMPFILE  >$TMPFILE.tmp 2>&1
		RESULT="${?}"
		rm -f $TMPFILE $TMPFILE.tmp
		if [ "${RESULT}" = "0" ]; then
			echo "<P><FONT COLOR=\"#008000\">Passwort ge&auml;ndert!</FONT>"
		    else
	    		echo "<P><FONT COLOR=\"#800000\">Zugriff vom Server abgelehnt!<br>(Altes Passwort falsch?)</FONT><BR>"
			FEHLER=1
	        fi
	     fi
	else
	     echo "<p>Sie haben sich bei der Eingabe des neuen Passworts vertippt!</p>"
	     FEHLER=1
fi

if [ $FEHLER = 1 ]; then
     echo "<p>Das Passwort wurde nicht ge&auml;ndert!</p>"
     echo "<p><a href=\"pass.php\"><img src=\"redarrow.gif\" align=bottom border=0 width=25 height=13>Versuchen Sie es noch einmal! </a></p>"
fi

cat << xxxxxEOFxxxxx
</H3></CENTER>
<hr>
<address>
Letzte &Auml;nderung: 29.06.2003
&copy; Reiner Klaproth
</address>
</body>
</html>
xxxxxEOFxxxxx

